// StreamingDialog.cpp
//

#include "../stdafx.h"

#include "CommonFunc.h"

#include "in_mpg123.h"

#include "HttpFile.h"
#include "ICYInfo.h"

#include "Param.h"
#include "StreamingDialog.h"
#include "PropertySheet.h"
#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStreamingDialog

IMPLEMENT_DYNCREATE(CStreamingDialog, CPropertyPage)

CStreamingDialog::CStreamingDialog() : CPropertyPage(CStreamingDialog::IDD)
{
	//{{AFX_DATA_INIT(CStreamingDialog)
	m_bEnableStreaming = false;
	m_strBufferLength = _T("");
	m_strProxy = _T("");
	m_strSaveStream = _T("");
	m_strTitleStreamingFormat = _T("");
	m_bProxy = false;
	m_bSaveStream = false;
	m_bTitleStreaming = false;
	m_bTitleStreamingDecode = false;
	m_bTitleStreamingUDP = false;
	//}}AFX_DATA_INIT

}

CStreamingDialog::~CStreamingDialog()
{
}

void CStreamingDialog::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStreamingDialog)
	DDX_Check(pDX, IDC_CH_ENABLE_STREAMING, m_bEnableStreaming);
	DDX_Control(pDX, IDC_COMBO_PRIORITY, m_comboReceivePriority);
	DDX_Text(pDX, IDC_ED_STRBUF, m_strBufferLength);
	DDX_Control(pDX, IDC_ED_TITLESTREAMING_FORMAT, m_editTitleStreamingFormat);
	DDX_Control(pDX, IDC_TITLESTREAMING_UDP, m_buttonTitleStreamingUDP);
	DDX_Control(pDX, IDC_TITLESTREAMING_DECODE, m_buttonTitleStreamingDecode);
	DDX_Control(pDX, IDC_BUTTON_FILEDIALOG, m_buttonFileDialog);
	DDX_Control(pDX, IDC_ED_PROXY, m_editProxy);
	DDX_Control(pDX, IDC_ED_STRBUF, m_editBufferLength);
	DDX_Control(pDX, IDC_ED_SAVESTREAM, m_editSaveStream);
	DDX_Text(pDX, IDC_ED_PROXY, m_strProxy);
	DDX_Text(pDX, IDC_ED_SAVESTREAM, m_strSaveStream);
	DDX_Text(pDX, IDC_ED_TITLESTREAMING_FORMAT, m_strTitleStreamingFormat);
	DDX_Check(pDX, IDC_PROXY, m_bProxy);
	DDX_Check(pDX, IDC_SAVESTREAM, m_bSaveStream);
	DDX_Check(pDX, IDC_TITLESTREAMING, m_bTitleStreaming);
	DDX_Check(pDX, IDC_TITLESTREAMING_DECODE, m_bTitleStreamingDecode);
	DDX_Check(pDX, IDC_TITLESTREAMING_UDP, m_bTitleStreamingUDP);
	//}}AFX_DATA_MAP

}


BEGIN_MESSAGE_MAP(CStreamingDialog, CPropertyPage)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStreamingDialog

void CStreamingDialog::OnOK()
{
	bool bFlag = false;

	UpdateData();

	pr->m_bEnableStreaming = m_bEnableStreaming != 0;

	if (pr->m_nReceiveThreadPriority != m_comboReceivePriority.GetCurSel())
	{
		pr->m_nReceiveThreadPriority = m_comboReceivePriority.GetCurSel();
		bFlag = true;
	}

	pr->m_nBufferLength = Max(atoi((LPCTSTR)m_strBufferLength), MIN_STREAM_SIZE / 1024);
	pr->m_strProxy = m_strProxy;
	pr->m_strSaveStream = m_strSaveStream;
	pr->m_strTitleStreamingFormat = m_strTitleStreamingFormat;
	pr->m_bProxy = m_bProxy != 0;
	pr->m_bSaveStream = m_bSaveStream != 0;
	pr->m_bTitleStreaming = m_bTitleStreaming != 0;
	pr->m_bTitleStreamingDecode = m_bTitleStreamingDecode != 0;
	pr->m_bTitleStreamingUDP = m_bTitleStreamingUDP != 0;

	CIn_mpg123dPropertySheet* pSheet = (CIn_mpg123dPropertySheet*)GetParent();
	pr->m_nStartPage = pSheet->GetActiveIndex();
	pSheet->ReflectSetting(bFlag);

	CPropertyPage::OnOK();
}

void CStreamingDialog::OnCancel()
{
	CPropertyPage::OnCancel();
}

void CStreamingDialog::OnKillfocusEdStrbuf()
{
	CString str;

	str = m_strBufferLength;

	UpdateData();

	int l;
	l = atoi((LPCTSTR)m_strBufferLength);
	if (l <= 0)
	{
		m_editBufferLength.SetWindowText(str);
	}
}

BOOL CStreamingDialog::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	if (!m_bProxy)
	{
		m_editProxy.EnableWindow(FALSE);
	}
	else
	{
		m_editProxy.EnableWindow(TRUE);
	}

	if (!m_bSaveStream)
	{
		m_editSaveStream.EnableWindow(FALSE);
		m_buttonFileDialog.EnableWindow(FALSE);
	}
	else
	{
		m_editSaveStream.EnableWindow(TRUE);
		m_buttonFileDialog.EnableWindow(TRUE);
	}

	if (!m_bTitleStreaming)
	{
		m_buttonTitleStreamingDecode.EnableWindow(FALSE);
		m_buttonTitleStreamingUDP.EnableWindow(FALSE);
	}
	else
	{
		m_buttonTitleStreamingDecode.EnableWindow(TRUE);
		m_buttonTitleStreamingUDP.EnableWindow(TRUE);
	}

	m_comboReceivePriority.SetCurSel(pr->m_nReceiveThreadPriority);

	UpdateData(FALSE);

	return TRUE;
}

void CStreamingDialog::OnButtonFiledialog()
{
	SetModified();

	CString str;

	str.LoadString(IDS_SAVESTREAMDLG);
	UpdateData();

	CFileDialog FileDialog(FALSE, "*.mp3", "notitle.mp3", OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, str, this, 0);

	UpdateData();
	if (FileDialog.DoModal() == IDOK)
	{
		m_editSaveStream.SetWindowText(FileDialog.GetPathName());
	}
}

void CStreamingDialog::SetParam()
{
	CString tmp;

	m_bEnableStreaming = pr->m_bEnableStreaming;
	m_strProxy = pr->m_strProxy;
	m_strSaveStream = pr->m_strSaveStream;
	tmp.Format("%d", pr->m_nBufferLength);
	m_strBufferLength = tmp;
	m_strTitleStreamingFormat = pr->m_strTitleStreamingFormat;
	m_bProxy = pr->m_bProxy;
	m_bSaveStream = pr->m_bSaveStream;
	m_bTitleStreaming = pr->m_bTitleStreaming;
	m_bTitleStreamingDecode = pr->m_bTitleStreamingDecode;
	m_bTitleStreamingUDP = pr->m_bTitleStreamingUDP;
}

void reflect_setting(void);
void reflect_thread_setting(void);

BOOL CALLBACK in_streaming_dialog_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{ 
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_THRAD_PRIORITY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_BUFFER_SIZE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_HTTP_PROXY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_SAVE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_TITLE_STREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_TITLE_FORMAT);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_EXAMPLE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_ENABLE_STREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_PROXY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_SAVESTREAM);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING_UDP);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_TITLESTREAMING_DECODE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LSTREAMING_KB);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_BUTTON_FILEDIALOG);
		
			SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_SETCHECK, prm->m_bEnableStreaming? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_PROXY, BM_SETCHECK, prm->m_bProxy? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_SETCHECK, prm->m_bSaveStream? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_SETCHECK, prm->m_bTitleStreaming? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_UDP, BM_SETCHECK, prm->m_bTitleStreamingUDP? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_DECODE, BM_SETCHECK, prm->m_bTitleStreamingDecode? BST_CHECKED : BST_UNCHECKED, 0);
			SetDlgItemText(hDlg, IDC_ED_SAVESTREAM, prm->m_strSaveStream);
			SetDlgItemText(hDlg, IDC_ED_PROXY, prm->m_strProxy);

			CString tmp;
			tmp.Format("%d", prm->m_nBufferLength);
			SetDlgItemText(hDlg, IDC_ED_STRBUF, tmp);
			SetDlgItemText(hDlg, IDC_ED_TITLESTREAMING_FORMAT, prm->m_strTitleStreamingFormat);

			CString buf = m_HelperIn.MyLoadString(IDS_LNORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LABOVENORMAL);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LHIGHEST);
			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);

			SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_SETCURSEL, prm->m_nReceiveThreadPriority, 0);

			SendMessage(hDlg, WM_COMMAND, IDC_TITLESTREAMING, 0);
			SendMessage(hDlg, WM_COMMAND, IDC_SAVESTREAM, 0);
			SendMessage(hDlg, WM_COMMAND, IDC_PROXY, 0);
			break;
		}
	case WM_NOTIFY:
		{
			LPPSHNOTIFY lppsn = (LPPSHNOTIFY)lParam;
			switch (lppsn->hdr.code)
			{
			case PSN_APPLY :
			{
				prm->m_bEnableStreaming = SendDlgItemMessage(hDlg, IDC_CH_ENABLE_STREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
				prm->m_bProxy = SendDlgItemMessage(hDlg, IDC_PROXY, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
				prm->m_bSaveStream = SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
				prm->m_bTitleStreaming = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
				prm->m_bTitleStreamingUDP = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_UDP, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
				prm->m_bTitleStreamingDecode = SendDlgItemMessage(hDlg, IDC_TITLESTREAMING_DECODE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
				CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_PROXY,prm->m_strProxy);
				CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_SAVESTREAM,prm->m_strSaveStream);
				CString tmp;
				CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_STRBUF,tmp);
				prm->m_nBufferLength = Max(atoi(tmp), MIN_STREAM_SIZE / 1024);
				CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_TITLESTREAMING_FORMAT, prm->m_strTitleStreamingFormat);

				bool bFlag = false;

				if (prm->m_nReceiveThreadPriority != SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_GETCURSEL, 0, 0))
				{
					prm->m_nReceiveThreadPriority = SendDlgItemMessage(hDlg, IDC_COMBO_PRIORITY, CB_GETCURSEL, 0, 0);
					bFlag = true;
				}
				if (bFlag)
				{
					::reflect_thread_setting();
				}
				::reflect_setting();
				break;
			}
			case PSN_QUERYCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				break;
			}
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_PROXY:
			if (SendDlgItemMessage(hDlg, IDC_PROXY, BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hDlg,IDC_ED_PROXY), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg,IDC_ED_PROXY), FALSE);
			}
			return FALSE;
		case IDC_SAVESTREAM:
			if (SendDlgItemMessage(hDlg, IDC_SAVESTREAM, BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hDlg,IDC_ED_SAVESTREAM), TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FILEDIALOG), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg,IDC_ED_SAVESTREAM), FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FILEDIALOG), FALSE);
			}
			return FALSE;
		case IDC_TITLESTREAMING:
			if (SendDlgItemMessage(hDlg, IDC_TITLESTREAMING, BM_GETCHECK, 0, 0) == BST_CHECKED)
			{
				EnableWindow(GetDlgItem(hDlg,IDC_TITLESTREAMING_DECODE), TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_TITLESTREAMING_UDP), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg,IDC_TITLESTREAMING_DECODE), FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_TITLESTREAMING_UDP), FALSE);
			}
			return FALSE;
		case IDC_BUTTON_FILEDIALOG:
			{
				CString str;

				str.LoadString(IDS_SAVESTREAMDLG);

				CFileDialog FileDialog(FALSE, "*.mp3", "notitle.mp3", OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, str, CWnd::FromHandle(hDlg), 0);
				if (FileDialog.DoModal() == IDOK)
				{
					SetDlgItemText(hDlg, IDC_ED_SAVESTREAM, FileDialog.GetPathName());
				}
				return FALSE;
			}
	case BN_CLICKED:
		break;
		case IDOK:
		case IDCANCEL:
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}

	return TRUE;
}

